package com.loafle.overflow.module.probe.model;

import com.loafle.overflow.module.domain.model.Domain;
import com.loafle.overflow.module.meta.model.MetaProbeStatus;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "PROBE", schema = "public", catalog = "postgres")
public class Probe {
    private long id;
    private MetaProbeStatus status;
    private String description;
    private Date createDate;
    private Date lastPollingDate;
    private Date nextPollingDate;
    private Domain domain;
    private String probeKey;
    private String encryptionKey;

    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    @ManyToOne
    @JoinColumn(name = "STATUS", nullable = false)
    public MetaProbeStatus getStatus() {
        return status;
    }

    public void setStatus(MetaProbeStatus status) {
        this.status = status;
    }


    @Column(name = "DESCRIPTION", nullable = true, length = 50)
    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "LAST_POLLING_DATE", columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP")
    public Date getLastPollingDate() {
        return lastPollingDate;
    }

    public void setLastPollingDate(Date lastPollingDate) {
        this.lastPollingDate = lastPollingDate;
    }

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "NEXT_POLLING_DATE", columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP")
    public Date getNextPollingDate() {
        return nextPollingDate;
    }

    public void setNextPollingDate(Date nextPollingDate) {
        this.nextPollingDate = nextPollingDate;
    }

    @ManyToOne
    @JoinColumn(name = "DOMAIN_ID", nullable = false)
    public Domain getDomain() {
        return domain;
    }

    public void setDomain(Domain domain) {
        this.domain = domain;
    }


    @Column(name = "PROBE_KEY", nullable = false, unique = true)
    public String getProbeKey() {
        return probeKey;
    }

    public void setProbeKey(String probeKey) {
        this.probeKey = probeKey;
    }


    @Column(name = "ENCRYPTION_KEY", nullable = false, length = 50, unique = true)
    public String getEncryptionKey() {
        return encryptionKey;
    }

    public void setEncryptionKey(String encryptionKey) {
        this.encryptionKey = encryptionKey;
    }

//    @Override
//    public boolean equals(Object o) {
//        if (this == o) return true;
//        if (o == null || getClass() != o.getClass()) return false;
//
//        Probe tblProbe = (Probe) o;
//
//        if (id != tblProbe.id) return false;
//        if (domain != tblProbe.domain) return false;
//        if (status != null ? !status.equals(tblProbe.status) : tblProbe.status != null) return false;
//        if (description != null ? !description.equals(tblProbe.description) : tblProbe.description != null)
//            return false;
//        if (createDate != null ? !createDate.equals(tblProbe.createDate) : tblProbe.createDate != null) return false;
//        if (lastPollingDate != null ? !lastPollingDate.equals(tblProbe.lastPollingDate) : tblProbe.lastPollingDate != null)
//            return false;
//        if (nextPollingDate != null ? !nextPollingDate.equals(tblProbe.nextPollingDate) : tblProbe.nextPollingDate != null)
//            return false;
//        if (probeKey != null ? !probeKey.equals(tblProbe.probeKey) : tblProbe.probeKey != null) return false;
//        if (encryptionKey != null ? !encryptionKey.equals(tblProbe.encryptionKey) : tblProbe.encryptionKey != null)
//            return false;
//
//        return true;
//    }

}
