package com.loafle.overflow.spring;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.mail.javamail.JavaMailSenderImpl;

import java.util.Properties;

/**
 * Created by geek on 17. 6. 28.
 */
@Configuration
@ComponentScan(basePackages = "com.loafle.overflow")
public class MailConfiguration {



    @Value("${mail.host}")
    private String host;
    @Value("${mail.port}")
    private int port;
    @Value("${mail.username}")
    private String username;
    @Value("${mail.password}")
    private String password;
    @Value("${mail.protocol}")
    private String protocol;

    @Bean
    public JavaMailSenderImpl mailSender() {
        JavaMailSenderImpl mailSender = new JavaMailSenderImpl();

        mailSender.setHost(this.host);
        mailSender.setPort(this.port);
        mailSender.setUsername(this.username);
        mailSender.setPassword(this.password);
        mailSender.setProtocol(this.protocol);

        mailSender.setJavaMailProperties(getJavaMailProperties());

        return mailSender;
    }

    @Bean
    public Properties getJavaMailProperties() {
        Properties javaMailProperties = new Properties();
        javaMailProperties.put("mail.smtp.starttls.enable", true);
        javaMailProperties.put("mail.smtp.auth", true);
        javaMailProperties.put("mail.transport.protocol", "smtp");
        javaMailProperties.put("mail.debug", "true");
        javaMailProperties.put("mail.smtps.ssl.checkserveridentity", true);
        javaMailProperties.put("mail.smtps.ssl.trust", "*");

        return javaMailProperties;
    }

}

//
//    @Value("${mail.properties.mail.smtp.auth}")
//    private boolean smtpAuth;
//    @Value("${mail.properties.mail.smtp.starttls.enable}")
//    private boolean ttlEnable;
//    @Value("${mail.transport.protocol}")
//    private String transProtocol;
//    @Value("${mail.smtps.ssl.checkserveridentity}")
//    private boolean checkserver;
//    @Value("${mail.smtps.ssl.trust}")
//    private String sslTrust;
